diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/radiotap-header.cc ns-3.47/src/network/utils/radiotap-header.cc
--- ns-3.46/src/network/utils/radiotap-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/radiotap-header.cc	2026-02-16 16:08:49.806230800 -0800
@@ -11,22 +11,109 @@
 
 #include "ns3/log.h"
 
-#include <bit>
+#include <algorithm>
+#include <bitset>
 #include <cmath>
 #include <iomanip>
 
 namespace ns3
 {
 
+namespace
+{
+/// Number of bits per "present" field in the radiotap header
+constexpr std::size_t RADIOTAP_BITS_PER_PRESENT_FIELD{32};
+/// Size in bytes of the TSFT field in the radiotap header
+constexpr uint16_t RADIOTAP_TSFT_SIZE_B = 8;
+/// Alignment in bytes of the TSFT field in the radiotap header
+constexpr uint16_t RADIOTAP_TSFT_ALIGNMENT_B = 8;
+/// Size in bytes of the Flags field in the radiotap header
+constexpr uint16_t RADIOTAP_FLAGS_SIZE_B = 1;
+/// Size in bytes of the Rate field in the radiotap header
+constexpr uint16_t RADIOTAP_RATE_SIZE_B = 1;
+/// Size in bytes of the Channel field in the radiotap header
+constexpr uint16_t RADIOTAP_CHANNEL_SIZE_B = 4;
+/// Alignment in bytes of the Channel field in the radiotap header
+constexpr uint16_t RADIOTAP_CHANNEL_ALIGNMENT_B = 2;
+/// Size in bytes of the Antenna Signal field in the radiotap header
+constexpr uint16_t RADIOTAP_ANTENNA_SIGNAL_SIZE_B = 1;
+/// Size in bytes of the Antenna Noise field in the radiotap header
+constexpr uint16_t RADIOTAP_ANTENNA_NOISE_SIZE_B = 1;
+/// Size in bytes of the MCS field in the radiotap header
+constexpr uint16_t RADIOTAP_MCS_SIZE_B = 3;
+/// Alignment in bytes of the MCS field in the radiotap header
+constexpr uint16_t RADIOTAP_MCS_ALIGNMENT_B = 1;
+/// Size in bytes of the A-MPDU status field in the radiotap header
+constexpr uint16_t RADIOTAP_AMPDU_STATUS_SIZE_B = 8;
+/// Alignment in bytes of the A-MPDU status field in the radiotap header
+constexpr uint16_t RADIOTAP_AMPDU_STATUS_ALIGNMENT_B = 4;
+/// Size in bytes of the VHT field in the radiotap header
+constexpr uint16_t RADIOTAP_VHT_SIZE_B = 12;
+/// Alignment in bytes of the VHT field in the radiotap header
+constexpr uint16_t RADIOTAP_VHT_ALIGNMENT_B = 2;
+/// Size in bytes of the HE field in the radiotap header
+constexpr uint16_t RADIOTAP_HE_SIZE_B = 12;
+/// Alignment in bytes of the HE field in the radiotap header
+constexpr uint16_t RADIOTAP_HE_ALIGNMENT_B = 2;
+/// Size in bytes of the HE MU field in the radiotap header
+constexpr uint16_t RADIOTAP_HE_MU_SIZE_B = 12;
+/// Alignment in bytes of the HE MU field in the radiotap header
+constexpr uint16_t RADIOTAP_HE_MU_ALIGNMENT_B = 2;
+/// Size in bytes of the HE MU Other User field in the radiotap header
+constexpr uint16_t RADIOTAP_HE_MU_OTHER_USER_SIZE_B = 6;
+/// Alignment in bytes of the HE MU Other User field in the radiotap header
+constexpr uint16_t RADIOTAP_HE_MU_OTHER_USER_ALIGNMENT_B = 2;
+/// Size in bytes of the TLV fields (without data) in the radiotap header
+constexpr uint16_t RADIOTAP_TLV_HEADER_SIZE_B = 4;
+/// Alignment in bytes of the TLV fields in the radiotap header
+constexpr uint16_t RADIOTAP_TLV_ALIGNMENT_B = 4;
+/// Size in bytes of the U-SIG field in the radiotap header
+constexpr uint16_t RADIOTAP_USIG_SIZE_B = 12;
+/// Alignment in bytes of the U-SIG field in the radiotap header
+constexpr uint16_t RADIOTAP_USIG_ALIGNMENT_B = 4;
+/// Size in bytes of the known subfield of the EHT field in the radiotap header
+constexpr uint16_t RADIOTAP_EHT_KNOWN_SIZE_B = 4;
+/// Size in bytes of a data subfield of the EHT field in the radiotap header
+constexpr uint16_t RADIOTAP_EHT_DATA_SIZE_B = 4;
+/// Size in bytes of a user info subfield of the EHT field in the radiotap header
+constexpr uint16_t RADIOTAP_EHT_USER_INFO_SIZE_B = 4;
+/// Alignment in bytes of the EHT field in the radiotap header
+constexpr uint16_t RADIOTAP_EHT_ALIGNMENT_B = 4;
+
+/**
+ * @brief Calculate the padding needed to align a field
+ * @param offset Current offset in bytes
+ * @param alignment Alignment requirement in bytes
+ * @return Number of padding bytes needed
+ */
+uint8_t
+GetPadding(uint32_t offset, uint32_t alignment)
+{
+    uint8_t padding = (alignment - (offset % alignment)) % alignment;
+    return padding;
+}
+
+/**
+ * @brief Check if a specific field is present in the radiotap header
+ * @param presentBits Vector of bitsets representing the present fields
+ * @param field Field to check
+ * @return true if the field is present, false otherwise
+ */
+bool
+IsPresent(const std::vector<std::bitset<RADIOTAP_BITS_PER_PRESENT_FIELD>>& presentBits,
+          uint32_t field)
+{
+    const std::size_t bitmaskIdx = field / RADIOTAP_BITS_PER_PRESENT_FIELD;
+    const std::size_t bitIdx = field % RADIOTAP_BITS_PER_PRESENT_FIELD;
+    return (presentBits.size() > bitmaskIdx) && presentBits.at(bitmaskIdx).test(bitIdx);
+}
+
+} // namespace
+
 NS_LOG_COMPONENT_DEFINE("RadiotapHeader");
 
 NS_OBJECT_ENSURE_REGISTERED(RadiotapHeader);
 
-RadiotapHeader::RadiotapHeader()
-{
-    NS_LOG_FUNCTION(this);
-}
-
 TypeId
 RadiotapHeader::GetTypeId()
 {
@@ -47,7 +134,6 @@
 uint32_t
 RadiotapHeader::GetSerializedSize() const
 {
-    NS_LOG_FUNCTION(this);
     return m_length;
 }
 
@@ -60,9 +146,11 @@
     start.WriteU8(0);         // pad field
     start.WriteU16(m_length); // entire length of radiotap data + header
     NS_ASSERT(!m_present.empty());
+    std::vector<std::bitset<RADIOTAP_BITS_PER_PRESENT_FIELD>> presentBits;
     for (const auto present : m_present)
     {
         start.WriteU32(present); // bits describing which fields follow header
+        presentBits.emplace_back(present);
     }
 
     //
@@ -70,7 +158,7 @@
     // arrived at the MAC)
     // Reference: https://www.radiotap.org/fields/TSFT.html
     //
-    if (m_present.at(0) & RADIOTAP_TSFT) // bit 0
+    if (IsPresent(presentBits, RADIOTAP_TSFT))
     {
         SerializeTsft(start);
     }
@@ -79,7 +167,7 @@
     // Properties of transmitted and received frames.
     // Reference: https://www.radiotap.org/fields/Flags.html
     //
-    if (m_present.at(0) & RADIOTAP_FLAGS) // bit 1
+    if (IsPresent(presentBits, RADIOTAP_FLAGS))
     {
         start.WriteU8(m_flags);
     }
@@ -88,7 +176,7 @@
     // TX/RX data rate in units of 500 kbps
     // Reference: https://www.radiotap.org/fields/Rate.html
     //
-    if (m_present.at(0) & RADIOTAP_RATE) // bit 2
+    if (IsPresent(presentBits, RADIOTAP_RATE))
     {
         start.WriteU8(m_rate);
     }
@@ -97,27 +185,17 @@
     // Tx/Rx frequency in MHz, followed by flags.
     // Reference: https://www.radiotap.org/fields/Channel.html
     //
-    if (m_present.at(0) & RADIOTAP_CHANNEL) // bit 3
+    if (IsPresent(presentBits, RADIOTAP_CHANNEL))
     {
         SerializeChannel(start);
     }
 
     //
-    // The hop set and pattern for frequency-hopping radios.  We don't need it but
-    // still need to account for it.
-    // Reference: https://www.radiotap.org/fields/FHSS.html
-    //
-    if (m_present.at(0) & RADIOTAP_FHSS) // bit 4
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
     // RF signal power at the antenna, decibel difference from an arbitrary, fixed
     // reference.
     // Reference: https://www.radiotap.org/fields/Antenna%20signal.html
     //
-    if (m_present.at(0) & RADIOTAP_DBM_ANTSIGNAL) // bit 5
+    if (IsPresent(presentBits, RADIOTAP_DBM_ANTSIGNAL))
     {
         start.WriteU8(m_antennaSignal);
     }
@@ -127,92 +205,16 @@
     // reference.
     // Reference: https://www.radiotap.org/fields/Antenna%20noise.html
     //
-    if (m_present.at(0) & RADIOTAP_DBM_ANTNOISE) // bit 6
+    if (IsPresent(presentBits, RADIOTAP_DBM_ANTNOISE))
     {
         start.WriteU8(m_antennaNoise);
     }
 
     //
-    // Quality of Barker code lock.
-    // Reference: https://www.radiotap.org/fields/Lock%20quality.html
-    //
-    if (m_present.at(0) & RADIOTAP_LOCK_QUALITY) // bit 7
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Transmit power expressed as unitless distance from max power
-    // set at factory calibration (0 is max power).
-    // Reference: https://www.radiotap.org/fields/TX%20attenuation.html
-    //
-    if (m_present.at(0) & RADIOTAP_TX_ATTENUATION) // bit 8
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Transmit power expressed as decibel distance from max power
-    // set at factory calibration (0 is max power).
-    // Reference: https://www.radiotap.org/fields/dB%20TX%20attenuation.html
-    //
-    if (m_present.at(0) & RADIOTAP_DB_TX_ATTENUATION) // bit 9
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Transmit power expressed as dBm (decibels from a 1 milliwatt reference).
-    // This is the absolute power level measured at the antenna port.
-    // Reference: https://www.radiotap.org/fields/dBm%20TX%20power.html
-    //
-    if (m_present.at(0) & RADIOTAP_DBM_TX_POWER) // bit 10
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Unitless indication of the Rx/Tx antenna for this packet.
-    // The first antenna is antenna 0.
-    // Reference: https://www.radiotap.org/fields/Antenna.html
-    //
-    if (m_present.at(0) & RADIOTAP_ANTENNA) // bit 11
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // RF signal power at the antenna (decibel difference from an arbitrary fixed reference).
-    // Reference: https://www.radiotap.org/fields/dB%20antenna%20signal.html
-    //
-    if (m_present.at(0) & RADIOTAP_DB_ANTSIGNAL) // bit 12
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // RF noise power at the antenna (decibel difference from an arbitrary fixed reference).
-    // Reference: https://www.radiotap.org/fields/dB%20antenna%20noise.html
-    //
-    if (m_present.at(0) & RADIOTAP_DB_ANTNOISE) // bit 13
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Properties of received frames.
-    // Reference: https://www.radiotap.org/fields/RX%20flags.html
-    //
-    if (m_present.at(0) & RADIOTAP_RX_FLAGS) // bit 14
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
     // MCS field.
     // Reference: https://www.radiotap.org/fields/MCS.html
     //
-    if (m_present.at(0) & RADIOTAP_MCS) // bit 19
+    if (IsPresent(presentBits, RADIOTAP_MCS))
     {
         SerializeMcs(start);
     }
@@ -221,7 +223,7 @@
     // A-MPDU Status, information about the received or transmitted A-MPDU.
     // Reference: https://www.radiotap.org/fields/A-MPDU%20status.html
     //
-    if (m_present.at(0) & RADIOTAP_AMPDU_STATUS) // bit 20
+    if (IsPresent(presentBits, RADIOTAP_AMPDU_STATUS))
     {
         SerializeAmpduStatus(start);
     }
@@ -230,7 +232,7 @@
     // Information about the received or transmitted VHT frame.
     // Reference: https://www.radiotap.org/fields/VHT.html
     //
-    if (m_present.at(0) & RADIOTAP_VHT) // bit 21
+    if (IsPresent(presentBits, RADIOTAP_VHT))
     {
         SerializeVht(start);
     }
@@ -239,7 +241,7 @@
     // HE field.
     // Reference: https://www.radiotap.org/fields/HE.html
     //
-    if (m_present.at(0) & RADIOTAP_HE) // bit 23
+    if (IsPresent(presentBits, RADIOTAP_HE))
     {
         SerializeHe(start);
     }
@@ -248,7 +250,7 @@
     // HE MU field.
     // Reference: https://www.radiotap.org/fields/HE-MU.html
     //
-    if (m_present.at(0) & RADIOTAP_HE_MU) // bit 24
+    if (IsPresent(presentBits, RADIOTAP_HE_MU))
     {
         SerializeHeMu(start);
     }
@@ -257,7 +259,7 @@
     // HE MU other user field.
     // Reference: https://www.radiotap.org/fields/HE-MU-other-user.html
     //
-    if (m_present.at(0) & RADIOTAP_HE_MU_OTHER_USER) // bit 25
+    if (IsPresent(presentBits, RADIOTAP_HE_MU_OTHER_USER))
     {
         SerializeHeMuOtherUser(start);
     }
@@ -266,7 +268,7 @@
     // U-SIG field.
     // Reference: https://www.radiotap.org/fields/U-SIG.html
     //
-    if ((m_present.size() > 1) && m_present.at(1) & RADIOTAP_USIG) // bit 33
+    if (IsPresent(presentBits, RADIOTAP_USIG))
     {
         SerializeUsig(start);
     }
@@ -275,7 +277,7 @@
     // EHT field.
     // Reference: https://www.radiotap.org/fields/EHT.html
     //
-    if ((m_present.size() > 1) && m_present.at(1) & RADIOTAP_EHT_SIG) // bit 34
+    if (IsPresent(presentBits, RADIOTAP_EHT))
     {
         SerializeEht(start);
     }
@@ -285,8 +287,9 @@
 RadiotapHeader::Deserialize(Buffer::Iterator start)
 {
     NS_LOG_FUNCTION(this << &start);
+    m_present.clear();
 
-    uint8_t tmp = start.ReadU8(); // major version of radiotap header
+    auto tmp = start.ReadU8(); // major version of radiotap header
     NS_ASSERT_MSG(tmp == 0x00, "RadiotapHeader::Deserialize(): Unexpected major version");
     start.ReadU8(); // pad field
 
@@ -295,27 +298,32 @@
     uint32_t bytesRead = MIN_HEADER_SIZE;
 
     std::size_t index{0};
-    while (m_present.at(index++) & RADIOTAP_EXT)
+    std::vector<std::bitset<RADIOTAP_BITS_PER_PRESENT_FIELD>> presentBits;
+    presentBits.emplace_back(m_present.at(0));
+    while (presentBits.at(index++).test(RADIOTAP_MORE_PRESENT))
     {
         // If bit 31 of the it_present field is set, another it_present bitmask is present.
         m_present.emplace_back(start.ReadU32());
-        bytesRead += 4;
+        bytesRead += (RADIOTAP_BITS_PER_PRESENT_FIELD / 8);
+        presentBits.emplace_back(m_present.at(index));
     }
 
     //
     // Time Synchronization Function Timer (when the first bit of the MPDU arrived at the MAC)
     // Reference: https://www.radiotap.org/fields/TSFT.html
     //
-    if (m_present.at(0) & RADIOTAP_TSFT) // bit 0
+    if (IsPresent(presentBits, RADIOTAP_TSFT))
     {
-        bytesRead += DeserializeTsft(start, bytesRead);
+        const auto size = DeserializeTsft(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // Properties of transmitted and received frames.
     // Reference: https://www.radiotap.org/fields/Flags.html
     //
-    if (m_present.at(0) & RADIOTAP_FLAGS) // bit 1
+    if (IsPresent(presentBits, RADIOTAP_FLAGS))
     {
         m_flags = start.ReadU8();
         ++bytesRead;
@@ -325,7 +333,7 @@
     // TX/RX data rate in units of 500 kbps
     // Reference: https://www.radiotap.org/fields/Rate.html
     //
-    if (m_present.at(0) & RADIOTAP_RATE) // bit 2
+    if (IsPresent(presentBits, RADIOTAP_RATE))
     {
         m_rate = start.ReadU8();
         ++bytesRead;
@@ -335,19 +343,11 @@
     // Tx/Rx frequency in MHz, followed by flags.
     // Reference: https://www.radiotap.org/fields/Channel.html
     //
-    if (m_present.at(0) & RADIOTAP_CHANNEL) // bit 3
+    if (IsPresent(presentBits, RADIOTAP_CHANNEL))
     {
-        bytesRead += DeserializeChannel(start, bytesRead);
-    }
-
-    //
-    // The hop set and pattern for frequency-hopping radios.  We don't need it but
-    // still need to account for it.
-    // Reference: https://www.radiotap.org/fields/FHSS.html
-    //
-    if (m_present.at(0) & RADIOTAP_FHSS) // bit 4
-    {
-        NS_ASSERT(false); // not yet implemented
+        const auto size = DeserializeChannel(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
@@ -355,7 +355,7 @@
     // reference.
     // Reference: https://www.radiotap.org/fields/Antenna%20signal.html
     //
-    if (m_present.at(0) & RADIOTAP_DBM_ANTSIGNAL) // bit 5
+    if (IsPresent(presentBits, RADIOTAP_DBM_ANTSIGNAL))
     {
         m_antennaSignal = start.ReadU8();
         ++bytesRead;
@@ -366,169 +366,108 @@
     // reference.
     // Reference: https://www.radiotap.org/fields/Antenna%20noise.html
     //
-    if (m_present.at(0) & RADIOTAP_DBM_ANTNOISE) // bit 6
+    if (IsPresent(presentBits, RADIOTAP_DBM_ANTNOISE))
     {
         m_antennaNoise = start.ReadU8();
         ++bytesRead;
     }
 
     //
-    // Quality of Barker code lock.
-    // Reference: https://www.radiotap.org/fields/Lock%20quality.html
-    //
-    if (m_present.at(0) & RADIOTAP_LOCK_QUALITY) // bit 7
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Transmit power expressed as unitless distance from max power
-    // set at factory calibration (0 is max power).
-    // Reference: https://www.radiotap.org/fields/TX%20attenuation.html
-    //
-    if (m_present.at(0) & RADIOTAP_TX_ATTENUATION) // bit 8
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Transmit power expressed as decibel distance from max power
-    // set at factory calibration (0 is max power).
-    // Reference: https://www.radiotap.org/fields/dB%20TX%20attenuation.html
-    //
-    if (m_present.at(0) & RADIOTAP_DB_TX_ATTENUATION) // bit 9
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Transmit power expressed as dBm (decibels from a 1 milliwatt reference).
-    // This is the absolute power level measured at the antenna port.
-    // Reference: https://www.radiotap.org/fields/dBm%20TX%20power.html
-    //
-    if (m_present.at(0) & RADIOTAP_DBM_TX_POWER) // bit 10
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Unitless indication of the Rx/Tx antenna for this packet.
-    // The first antenna is antenna 0.
-    // Reference: https://www.radiotap.org/fields/Antenna.html
-    //
-    if (m_present.at(0) & RADIOTAP_ANTENNA) // bit 11
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // RF signal power at the antenna (decibel difference from an arbitrary fixed reference).
-    // Reference: https://www.radiotap.org/fields/dB%20antenna%20signal.html
-    //
-    if (m_present.at(0) & RADIOTAP_DB_ANTSIGNAL) // bit 12
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // RF noise power at the antenna (decibel difference from an arbitrary fixed reference).
-    // Reference: https://www.radiotap.org/fields/dB%20antenna%20noise.html
-    //
-    if (m_present.at(0) & RADIOTAP_DB_ANTNOISE) // bit 13
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
-    // Properties of received frames.
-    // Reference: https://www.radiotap.org/fields/RX%20flags.html
-    //
-    if (m_present.at(0) & RADIOTAP_RX_FLAGS) // bit 14
-    {
-        NS_ASSERT(false); // not yet implemented
-    }
-
-    //
     // MCS field.
     // Reference: https://www.radiotap.org/fields/MCS.html
     //
-    if (m_present.at(0) & RADIOTAP_MCS) // bit 19
+    if (IsPresent(presentBits, RADIOTAP_MCS))
     {
-        bytesRead += DeserializeMcs(start, bytesRead);
+        const auto size = DeserializeMcs(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // A-MPDU Status, information about the received or transmitted A-MPDU.
     // Reference: https://www.radiotap.org/fields/A-MPDU%20status.html
     //
-    if (m_present.at(0) & RADIOTAP_AMPDU_STATUS)
+    if (IsPresent(presentBits, RADIOTAP_AMPDU_STATUS))
     {
-        bytesRead += DeserializeAmpduStatus(start, bytesRead);
+        const auto size = DeserializeAmpduStatus(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // Information about the received or transmitted VHT frame.
     // Reference: https://www.radiotap.org/fields/VHT.html
     //
-    if (m_present.at(0) & RADIOTAP_VHT) // bit 21
+    if (IsPresent(presentBits, RADIOTAP_VHT))
     {
-        bytesRead += DeserializeVht(start, bytesRead);
+        const auto size = DeserializeVht(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // HE field.
     // Reference: https://www.radiotap.org/fields/HE.html
     //
-    if (m_present.at(0) & RADIOTAP_HE) // bit 23
+    if (IsPresent(presentBits, RADIOTAP_HE))
     {
-        bytesRead += DeserializeHe(start, bytesRead);
+        const auto size = DeserializeHe(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // HE MU field.
     // Reference: https://www.radiotap.org/fields/HE-MU.html
     //
-    if (m_present.at(0) & RADIOTAP_HE_MU) // bit 24
+    if (IsPresent(presentBits, RADIOTAP_HE_MU))
     {
-        bytesRead += DeserializeHeMu(start, bytesRead);
+        const auto size = DeserializeHeMu(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // HE MU other user field.
     // Reference: https://www.radiotap.org/fields/HE-MU-other-user.html
-    //
-    if (m_present.at(0) & RADIOTAP_HE_MU_OTHER_USER) // bit 25
+    if (IsPresent(presentBits, RADIOTAP_HE_MU_OTHER_USER))
     {
-        bytesRead += DeserializeHeMuOtherUser(start, bytesRead);
+        const auto size = DeserializeHeMuOtherUser(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // U-SIG field.
     // Reference: https://www.radiotap.org/fields/U-SIG.html
     //
-    if ((m_present.size() > 1) && m_present.at(1) & RADIOTAP_USIG) // bit 33
+    if (IsPresent(presentBits, RADIOTAP_USIG))
     {
-        bytesRead += DeserializeUsig(start, bytesRead);
+        const auto size = DeserializeUsig(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     //
     // EHT field.
     // Reference: https://www.radiotap.org/fields/EHT.html
     //
-    if ((m_present.size() > 1) && m_present.at(1) & RADIOTAP_EHT_SIG) // bit 34
+    if (IsPresent(presentBits, RADIOTAP_EHT))
     {
-        bytesRead += DeserializeEht(start, bytesRead);
+        const auto size = DeserializeEht(start, bytesRead);
+        start.Next(size);
+        bytesRead += size;
     }
 
     NS_ASSERT_MSG(m_length == bytesRead,
-                  "RadiotapHeader::Deserialize(): expected and actual lengths inconsistent");
+                  "RadiotapHeader::Deserialize(): expected and actual lengths inconsistent ("
+                      << m_length << " != " << bytesRead << ")");
     return bytesRead;
 }
 
 void
 RadiotapHeader::Print(std::ostream& os) const
 {
-    NS_LOG_FUNCTION(this << &os);
     os << " tsft=" << m_tsft << " flags=" << std::hex << m_flags << std::dec << " rate=" << +m_rate;
     if (m_present.at(0) & RADIOTAP_CHANNEL)
     {
@@ -563,13 +502,43 @@
     {
         PrintUsig(os);
     }
-    if ((m_present.size() > 1) && m_present.at(1) & RADIOTAP_EHT_SIG)
+    if ((m_present.size() > 1) && m_present.at(1) & RADIOTAP_EHT)
     {
         PrintEht(os);
     }
 }
 
 void
+RadiotapHeader::UpdatePresentField(uint32_t field)
+{
+    NS_LOG_FUNCTION(this << field);
+    const std::size_t bitmaskIdx = field / RADIOTAP_BITS_PER_PRESENT_FIELD;
+    NS_ASSERT_MSG(bitmaskIdx < m_present.size(),
+                  "Number of it_present words (" << m_present.size()
+                                                 << ") less than expected index " << bitmaskIdx);
+    const std::size_t fieldIdx = field % RADIOTAP_BITS_PER_PRESENT_FIELD;
+    const uint32_t flag = (1 << fieldIdx);
+    if (field != RADIOTAP_TLV)
+    {
+        NS_ASSERT_MSG(!(m_present.at(bitmaskIdx) & flag),
+                      "Radiotap field " << field << " already set in present field at index "
+                                        << bitmaskIdx);
+        NS_ASSERT_MSG((m_present.at(bitmaskIdx) < flag) &&
+                          ((m_present.size() == (bitmaskIdx + 1)) ||
+                           std::all_of(m_present.begin() + bitmaskIdx + 1,
+                                       m_present.end(),
+                                       [](uint32_t present) { return present == 0; })),
+                      "Radiotap fields not set in correct order");
+    }
+    if (const uint32_t morePresentWordFlag = (1 << RADIOTAP_MORE_PRESENT); bitmaskIdx > 0)
+    {
+        // Ensure that the bit indicating more present words is set in the previous word
+        m_present.at(bitmaskIdx - 1) |= morePresentWordFlag;
+    }
+    m_present.at(bitmaskIdx) |= flag;
+}
+
+void
 RadiotapHeader::SetWifiHeader(std::size_t numPresentWords)
 {
     NS_LOG_FUNCTION(this << numPresentWords);
@@ -580,9 +549,8 @@
     NS_ASSERT_MSG(m_present.size() == 1, "RadiotapHeader::SetWifiHeader() should be called once");
     for (std::size_t i = 0; i < (numPresentWords - 1); ++i)
     {
-        m_present.at(i) |= RADIOTAP_EXT;
         m_present.emplace_back(0);
-        m_length += sizeof(RadiotapExtFlags);
+        m_length += (RADIOTAP_BITS_PER_PRESENT_FIELD / 8);
     }
 }
 
@@ -591,19 +559,19 @@
 {
     NS_LOG_FUNCTION(this << value);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_TSFT), "TSFT radiotap field already present");
-    m_tsftPad = ((8 - m_length % 8) % 8);
-    m_present.at(0) |= RADIOTAP_TSFT;
-    m_length += 8 + m_tsftPad;
+    UpdatePresentField(RADIOTAP_TSFT);
+    m_tsftPad = GetPadding(m_length, RADIOTAP_TSFT_ALIGNMENT_B);
+    m_length += RADIOTAP_TSFT_SIZE_B + m_tsftPad;
     m_tsft = value;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeTsft(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_tsftPad);
     start.WriteU64(m_tsft);
 }
@@ -611,38 +579,37 @@
 uint32_t
 RadiotapHeader::DeserializeTsft(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_tsftPad = ((8 - bytesRead % 8) % 8);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_tsftPad = GetPadding(bytesRead, RADIOTAP_TSFT_ALIGNMENT_B);
     start.Next(m_tsftPad);
     m_tsft = start.ReadU64();
-    return sizeof(m_tsft) + m_tsftPad;
+    return RADIOTAP_TSFT_SIZE_B + m_tsftPad;
 }
 
 void
 RadiotapHeader::SetFrameFlags(uint8_t flags)
 {
-    NS_LOG_FUNCTION(this << +flags);
+    NS_LOG_FUNCTION(this << flags);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_FLAGS), "Flags radiotap field already present");
-    m_present.at(0) |= RADIOTAP_FLAGS;
-    m_length += 1;
+    UpdatePresentField(RADIOTAP_FLAGS);
+    m_length += RADIOTAP_FLAGS_SIZE_B;
     m_flags = flags;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SetRate(uint8_t rate)
 {
-    NS_LOG_FUNCTION(this << +rate);
+    NS_LOG_FUNCTION(this << rate);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_RATE), "Rate radiotap field already present");
-    m_present.at(0) |= RADIOTAP_RATE;
-    m_length += 1;
+    UpdatePresentField(RADIOTAP_RATE);
+    m_length += RADIOTAP_RATE_SIZE_B;
     m_rate = rate;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
@@ -650,19 +617,19 @@
 {
     NS_LOG_FUNCTION(this << channelFields.frequency << channelFields.flags);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_CHANNEL), "Channel radiotap field already present");
-    m_channelPad = ((2 - m_length % 2) % 2);
-    m_present.at(0) |= RADIOTAP_CHANNEL;
-    m_length += (sizeof(ChannelFields) + m_channelPad);
+    UpdatePresentField(RADIOTAP_CHANNEL);
+    m_channelPad = GetPadding(m_length, RADIOTAP_CHANNEL_ALIGNMENT_B);
+    m_length += RADIOTAP_CHANNEL_SIZE_B + m_channelPad;
     m_channelFields = channelFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeChannel(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_channelPad);
     start.WriteU16(m_channelFields.frequency);
     start.WriteU16(m_channelFields.flags);
@@ -671,11 +638,12 @@
 uint32_t
 RadiotapHeader::DeserializeChannel(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_channelPad = ((2 - bytesRead % 2) % 2);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_channelPad = GetPadding(bytesRead, RADIOTAP_CHANNEL_ALIGNMENT_B);
     start.Next(m_channelPad);
     m_channelFields.frequency = start.ReadU16();
     m_channelFields.flags = start.ReadU16();
-    return sizeof(ChannelFields) + m_channelPad;
+    return RADIOTAP_CHANNEL_SIZE_B + m_channelPad;
 }
 
 void
@@ -690,10 +658,8 @@
 {
     NS_LOG_FUNCTION(this << signal);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_DBM_ANTSIGNAL),
-                  "Antenna signal radiotap field already present");
-    m_present.at(0) |= RADIOTAP_DBM_ANTSIGNAL;
-    m_length += 1;
+    UpdatePresentField(RADIOTAP_DBM_ANTSIGNAL);
+    m_length += RADIOTAP_ANTENNA_SIGNAL_SIZE_B;
 
     if (signal > 127)
     {
@@ -708,8 +674,8 @@
         m_antennaSignal = static_cast<int8_t>(floor(signal + 0.5));
     }
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
@@ -717,10 +683,8 @@
 {
     NS_LOG_FUNCTION(this << noise);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_DBM_ANTNOISE),
-                  "Antenna noise radiotap field already present");
-    m_present.at(0) |= RADIOTAP_DBM_ANTNOISE;
-    m_length += 1;
+    UpdatePresentField(RADIOTAP_DBM_ANTNOISE);
+    m_length += RADIOTAP_ANTENNA_NOISE_SIZE_B;
 
     if (noise > 127.0)
     {
@@ -735,27 +699,29 @@
         m_antennaNoise = static_cast<int8_t>(floor(noise + 0.5));
     }
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SetMcsFields(const McsFields& mcsFields)
 {
-    NS_LOG_FUNCTION(this << +mcsFields.known << +mcsFields.flags << +mcsFields.mcs);
+    NS_LOG_FUNCTION(this << mcsFields.known << mcsFields.flags << mcsFields.mcs);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_MCS), "MCS radiotap field already present");
-    m_present.at(0) |= RADIOTAP_MCS;
-    m_length += sizeof(McsFields);
+    UpdatePresentField(RADIOTAP_MCS);
+    m_mcsPad = GetPadding(m_length, RADIOTAP_MCS_ALIGNMENT_B);
+    m_length += RADIOTAP_MCS_SIZE_B + m_mcsPad;
     m_mcsFields = mcsFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeMcs(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
+    start.WriteU8(0, m_mcsPad);
     start.WriteU8(m_mcsFields.known);
     start.WriteU8(m_mcsFields.flags);
     start.WriteU8(m_mcsFields.mcs);
